// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.commons.converter;

import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import java.util.TimeZone;
import java.util.Locale;


public class ConvertDateTimeTag
    extends javax.faces.webapp.ConverterTag
{

    public ConvertDateTimeTag()
    {
        setConverterId("org.apache.myfaces.custom.convertDateTime.DateTimeConverter");
    }
 
    private String _dateStyle;
    
    public void setDateStyle(String dateStyle)
    {
        _dateStyle = dateStyle;
    }
 
    private String _locale;
    
    public void setLocale(String locale)
    {
        _locale = locale;
    }
 
    private String _pattern;
    
    public void setPattern(String pattern)
    {
        _pattern = pattern;
    }
 
    private String _timeStyle;
    
    public void setTimeStyle(String timeStyle)
    {
        _timeStyle = timeStyle;
    }
 
    private String _timeZone;
    
    public void setTimeZone(String timeZone)
    {
        _timeZone = timeZone;
    }
 
    private String _type;
    
    public void setType(String type)
    {
        _type = type;
    }

    public void setPageContext(PageContext context) {
        super.setPageContext(context);
        setConverterId("org.apache.myfaces.custom.convertDateTime.DateTimeConverter");
    }

    protected Converter createConverter() throws JspException {
    
        FacesContext facesContext = FacesContext.getCurrentInstance();            
        org.apache.myfaces.commons.converter.DateTimeConverter converter = (org.apache.myfaces.commons.converter.DateTimeConverter)super.createConverter();
        if (_dateStyle != null)
        {
            if (UIComponentTag.isValueReference(_dateStyle))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_dateStyle);
                converter.setValueBinding("dateStyle", vb);
            }
            else
            {
                converter.setDateStyle(_dateStyle);
            }
        }
        if (_locale != null)
        {
            if (UIComponentTag.isValueReference(_locale))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_locale);
                converter.setValueBinding("locale", vb);
            }
            else
            {
                converter.setLocale(
                    org.apache.myfaces.commons.util.TagUtils.getLocale(_locale));
            }
        }
        if (_pattern != null)
        {
            if (UIComponentTag.isValueReference(_pattern))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_pattern);
                converter.setValueBinding("pattern", vb);
            }
            else
            {
                converter.setPattern(_pattern);
            }
        }
        if (_timeStyle != null)
        {
            if (UIComponentTag.isValueReference(_timeStyle))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_timeStyle);
                converter.setValueBinding("timeStyle", vb);
            }
            else
            {
                converter.setTimeStyle(_timeStyle);
            }
        }
        if (_timeZone != null)
        {
            if (UIComponentTag.isValueReference(_timeZone))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_timeZone);
                converter.setValueBinding("timeZone", vb);
            }
            else
            {
                converter.setTimeZone(
                    java.util.TimeZone.getTimeZone(_timeZone));                
            }
        }
        if (_type != null)
        {
            if (UIComponentTag.isValueReference(_type))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_type);
                converter.setValueBinding("type", vb);
            }
            else
            {
                converter.setType(_type);
            }
        }
        return converter;
    }

    public void release()
    {
        super.release();
        _dateStyle = null;
        _locale = null;
        _pattern = null;
        _timeStyle = null;
        _timeZone = null;
        _type = null;
    }
}
